/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-16 19:40
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
struct rem {
  pair<int,int> nr;
  int p;
};
bool cmp(rem &a, rem &b){ return a.nr < b.nr; }
struct suffix_array{
  int N, LG;
  vector<vector<int>> p;
  vector<int> array, rank;
  suffix_array(const string &s){
    N = size(s), LG = __bit_width(N) + 1;
    p.emplace_back(begin(s), end(s));
    rem L[N];
    for (int stp = 1; stp < LG; stp++){
      int cnt = 1 << (stp - 1);
      for (int i = 0; i < N; i++)
        L[i] = {{p[stp - 1][i],
          i + cnt < N ? p[stp-1][i+cnt] : -1}, i};
      sort(L, L + N, cmp);
      p.emplace_back(N); // 0-init vector in-place
      for (int i = 0; i < N; i++)
        p[stp][L[i].p] = i>0 && L[i].nr==L[i-1].nr
            ? p[stp][L[i-1].p] : i;
    }
    rank = vector<int>(p[LG - 1]);
    array = vector<int>(N);
    for(int i = 0; i < N; i++)
      array[rank[i]] = i;
  }
  int lcp(int i, int j){
    int res = 0;
    for(int k = LG - 1; 0 <= k && i<N && j<N; k--)
      if(p[k][i] == p[k][j])
        res += 1 << k, i += 1 << k, j += 1 << k;
    return res;
  }
  int compare(int i, int j, int l){
    if(l == 0) return p[0][i] == p[0][j];
    int k = __bit_width(l) - 1;
    pair<int,int> pi(p[k][i], p[k][i+l-(1<<k)]);
    pair<int,int> pj(p[k][j], p[k][j+l-(1<<k)]);
    return pi == pj ? 0 : pi < pj ? -1 : 1;
  }
  ll substrcnt() { // without the empty word
    ll total = N-array[0];
    for (int i=1; i<N; i++)
      total += (N-array[i]) - lcp(array[i],array[i-1]);
    return total;
  } // very wrong until now !!!
};

/* const int MAXN = 2e5 + 5; */
string s;
vector<string> bf;
int N, M;

void solve(){
    // Code goes here ...
    cin >> s >> M;
    N = ssize(s);
    bf = vector<string>(M);
    R(i, M) cin >> bf[i];

    suffix_array sa(s);
    suffix_array rsa(s.reverse());

    for(string word: bf){
        auto p = [sa, word](int pos){
            /* int v = sa.array[pos]; */
            return s.substr(pos, N - pos) < word;
        };

        auto it = partition_point(begin(sa.array), end(sa.array), p);
        int v = *(it - 1), w = *it;
        string wb = s.substr(v, N-v), wa = s.substr(w, N-w);
        fprintf(stderr, "%s is bet %s and %s\n", word.c_str(), wb.c_str(), wa.c_str());
        int lb, la;
        while(word[lb] == wa[lb]) lb++;
        while(word[la] == wa[la]) la++;
        int l = max(la, lb);


    }

}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    /* cin >> T; */
    while(T--)
        solve();

    return 0;
}
        
